module GerbilCharts::SVGDC

# = SVGCircle 
# Draws a circle at x, y, and radius r
#
class SVGCircle < SVGShape
  
  attr_accessor :x,:y,:r
  
  def initialize(x,y,r)
    @x,@y,@r=x,y,r
    super()
  end
  
  def render(xfrag)
    h = { :cx => @x, :cy => @y, :r => @r }
    xfrag.circle(h.merge(render_attributes))
  end
  
end


class SVGCircleText < SVGCircle

  attr_accessor :txt

  def initialize(x,y,r,text)
  	super(x,y,r)
	@txt=text 
  end
  
  def render(xfrag)
  	super(xfrag)
    h = { "text-anchor" => "middle" , :x => @x, :y => @y, :class => 'legendtext'  }
    xfrag.text(@txt,  h ) 
  end

end


end
