module GerbilCharts::SVGDC

# = SVGPolygon
#
# A polygon identified by the operstring. Sorry this is not the best way to do it
# The oper string consists of M x y L x y style commands. See SVG spec.
# todo : accept an array of coords and automatically construct the oper string
#
POLYGON_RESOLUTION="%.1f"

class SVGPolygon < SVGShape

  attr_reader :operstring
  
  def initialize
    @operstring = ""
	@last_svg = ""
  end
  
  def addpoint(x,y)
    # truncate to 2 significant places (cuts down SVG size)
    xf,yf = POLYGON_RESOLUTION%x, POLYGON_RESOLUTION%y
	s = "#{xf},#{yf} "
    @operstring << "#{xf},#{yf} " unless s == @last_svg
	@last_svg = s
  end
  
  def render(xfrag)
    h= {:points => @operstring }
    xfrag.polygon( h.merge(render_attributes))
  end
  
  def isempty?
    return @operstring.length==0
  end
  
end


class SVGSquarizedPolygon < SVGPolygon


  def addpoint(x,y)
  	@lastpt ||= [] 
	
    # truncate to 2 significant places (cuts down SVG size)
    s = " #{POLYGON_RESOLUTION%x}, #{POLYGON_RESOLUTION%y} "

	unless s == @last_svg  or  @lastpt.empty?
			@operstring << " #{POLYGON_RESOLUTION%x}, #{POLYGON_RESOLUTION%@lastpt[1]} "
			@operstring << s
	end

	@lastpt = [x,y]
	@last_svg = s
  end
  
end

end
