module GerbilCharts::SVGDC

# = SVGPolyLine
# A polyline, like the polygon class 
#
# Send this a series of lineto messages
#
#

class SVGPolyline < SVGShape
  
  POLYLINE_RESOLUTION="%.1f"

  attr_reader :operstring
  
  def initialize
    @operstring = ""
	@last_svg = ""
  end
  
  def lineto(x,y)
    s = "#{POLYLINE_RESOLUTION%x},#{POLYLINE_RESOLUTION%y} "
    @operstring.concat(s) unless @last_svg == s
	@last_svg=s
  end
  
  def render(xfrag)
    h= {:points => @operstring }
    xfrag.polyline( h.merge(render_attributes))
  end
  
end

end
